--PetAssist v1.04 Liqudator Silvermoon(US)
local color = {r=1, b=0, g=0}
local _, Class = UnitClass("player")

--Command Lines
SLASH_MESSAGE1 = "/pa"
SlashCmdList["MESSAGE"] = function(msg)
    Command_Handler(msg)
end
--
function Frame1_OnLoad(frame)
    --Check to make sure the player is a Hunter, or don't bother loading the events..
    if (Class ~= "HUNTER") then
        DEFAULT_CHAT_FRAME:AddMessage("Not Loading, You are not a Hunter")
        PetAssistFrame:Hide()
    else
        GrowlWarning = 1 --Set Default Warning Values
        FeedWarning = 1 
        HealWarning = 1
        HealPercent = 35
        frame:RegisterEvent("VARIABLES_LOADED") -- Saved Variabled are loaded
        frame:RegisterEvent("UNIT_HAPPINESS")
        frame:RegisterEvent("PLAYER_REGEN_DISABLED")
        frame:RegisterEvent("UNIT_HEALTH")
        DEFAULT_CHAT_FRAME:AddMessage("Pet Assistant Loaded! /pa for options")	
        PetAssistFrame:Hide() -- Hide the frame by default, as this frame dose nothing at this time.
    end
end
--
function Frame1_OnEvent(frame, event, eff_unit, ...)
local petName = UnitName("pet")
local _, Growl=GetSpellAutocast("Growl", BOOKTYPE_PET) --Check to see if Grolw is on already

local in_party  = ((GetNumRaidMembers() > 0) or (GetNumPartyMembers() > 0)) 
    
    if (event == "VARIABLES_LOADED") then
      --  local debugmsg = string.format("GrowlWarning = %d, FeedWarning = %d, HealWarning = %d, HealPercent = %d ", GrowlWarning, FeedWarning, HealWarning, HealPercent)
      --  DEFAULT_CHAT_FRAME:AddMessage(debugmsg)
    end
    if (event == "PLAYER_REGEN_DISABLED") and UnitExists("pet") then -- If in combat & you have a pet.

        if (not Growl) and (not in_party) and (GrowlWarning == 1)then
            RaidNotice_AddMessage(RaidWarningFrame, "Turn On Growl", color)
        elseif (in_party and Growl) then
            RaidNotice_AddMessage(RaidWarningFrame, "Turn Growl Off", color)
        end
    end
    --
    if (event == "UNIT_HAPPINESS") and (not InCombatLockdown()) and (FeedWarning == 1) then --if in combat do not warn about feeding the pet.
        local isHappy = GetPetHappiness()
            if (isHappy == 1) then
                RaidNotice_AddMessage(RaidWarningFrame, "YOU REALLY NEED TO FEED " .. petName, color)--The Pet is REALLY NOT HAPPY!
            elseif (isHappy == 2) then
                RaidNotice_AddMessage(RaidWarningFrame, "You Need To Feed " .. petName, color)
            end
    end
    if (event == "UNIT_HEALTH") and (HealWarning == 1) then
      -- local eff_unit = ...
        if (eff_unit == "pet") then
            local pet_max = UnitHealthMax("pet")   
            local pet_cur = UnitHealth("pet")   
            local petpercent = pet_cur / pet_max * 100 -- Calculate % of Pet Health
            if (petpercent <= HealPercent) then
                RaidNotice_AddMessage(RaidWarningFrame, "Heal " .. petName, color)
            end
        end
    end
end
-- 
function Command_Handler(msg)
    local switch = msg
        if (switch == "show") then
            if (GrowlWarning == 1) then 
                DEFAULT_CHAT_FRAME:AddMessage("**Growl Warnign is ON")
            elseif (GrowlWarning ~= 1) then 
                DEFAULT_CHAT_FRAME:AddMessage("**Growl Warning is OFF")
            end
            if (FeedWarning == 1) then
                DEFAULT_CHAT_FRAME:AddMessage("**Feed Pet Warning is ON")
            elseif (FeedWarning ~= 1) then
                DEFAULT_CHAT_FRAME:AddMessage("**Feed Pet Warning is OFF")
            end
            if (HealWarning == 1) then
                DEFAULT_CHAT_FRAME:AddMessage("Heal Warning is ON")
                DEFAULT_CHAT_FRAME:AddMessage("Heal Warning Percent is set to " .. HealPercent)
            elseif (HealWarning ~= 1) then
                DEFAULT_CHAT_FRAME:AddMessage("Heal Warnings is OFF")
            end
        elseif (switch == "") then
            DEFAULT_CHAT_FRAME:AddMessage("growl off Will turn the growl warning OFF")
            DEFAULT_CHAT_FRAME:AddMessage("growl on Will turn the growl warning ON")
            DEFAULT_CHAT_FRAME:AddMessage("feed off Will turn the feed warning OFF")
            DEFAULT_CHAT_FRAME:AddMessage("feed on Will turn the feed warning ON")
            DEFAULT_CHAT_FRAME:AddMessage("heal off Will turn the healing warning OFF")
            DEFAULT_CHAT_FRAME:AddMessage("heal on Will turn the healing warning ON")
            DEFAULT_CHAT_FRAME:AddMessage("show will show the current state of all the warnings")

        elseif (switch == "growl off") then
            GrowlWarning = 0
            DEFAULT_CHAT_FRAME:AddMessage("**Growl Warning OFF")
        elseif (switch == "growl on") then
            GrowlWarning = 1
            DEFAULT_CHAT_FRAME:AddMessage("**Growl Warning ON")
        elseif (switch == "feed off") then
            FeedWarning = 0
            DEFAULT_CHAT_FRAME:AddMessage("**Feed Pet Warning OFF")
        elseif (switch == "feed on") then
            FeedWarning = 1
            DEFAULT_CHAT_FRAME:AddMessage("**Feed Pet Warning ON")
        elseif (switch == "heal on") then 
            HealWarning = 1
            DEFAULT_CHAT_FRAME:AddMessage("**Heal Warning ON")
        elseif (switch == "heal off") then
            HealWarning = 0
            DEFAULT_CHAT_FRAME:AddMessage("**Heal Warning OFF")
        end
end